import{s as ee,o as te,n as ne}from"../chunks/scheduler.f7e1785c.js";import{S as oe,i as ae,g as l,s as g,p as J,A as se,h,f as t,c as y,j as U,q as K,m,k as M,v as C,a as o,r as V,d as Q,t as W,u as Z,x as j,y as D}from"../chunks/index.5acad154.js";import{T as ie}from"../chunks/Tip.6231ad59.js";import{I as re}from"../chunks/IconCopyLink.31265512.js";function le(H){let s,c,d="requirements.txt",u,p,f="transformers",v,i,$="<code>git+https://github.com/hollance/transformers.git@6900e8ba6532162a8613d2270ec2286c3f58f57b</code>";return{c(){s=j(`In our experience experimenting with the Dutch language, using an MMS TTS checkpoint results in better performance than a
    fine-tuned SpeechT5 one, but you might find that your fine-tuned TTS checkpoint is preferable in your language.
    If you decide to use an MMS TTS checkpoint, you will need to update the `),c=l("a"),c.textContent=d,u=j(`
    file of your demo to install `),p=l("code"),p.textContent=f,v=j(` from the PR branch:
    `),i=l("p"),i.innerHTML=$,this.h()},l(a){s=D(a,`In our experience experimenting with the Dutch language, using an MMS TTS checkpoint results in better performance than a
    fine-tuned SpeechT5 one, but you might find that your fine-tuned TTS checkpoint is preferable in your language.
    If you decide to use an MMS TTS checkpoint, you will need to update the `),c=h(a,"A",{href:!0,"data-svelte-h":!0}),m(c)!=="svelte-l0vtp8"&&(c.textContent=d),u=D(a,`
    file of your demo to install `),p=h(a,"CODE",{"data-svelte-h":!0}),m(p)!=="svelte-olzpwg"&&(p.textContent=f),v=D(a,` from the PR branch:
    `),i=h(a,"P",{"data-svelte-h":!0}),m(i)!=="svelte-1oo2kle"&&(i.innerHTML=$),this.h()},h(){M(c,"href","https://huggingface.co/spaces/course-demos/speech-to-speech-translation/blob/a03175878f522df7445290d5508bfb5c5178f787/requirements.txt#L2")},m(a,r){o(a,s,r),o(a,c,r),o(a,u,r),o(a,p,r),o(a,v,r),o(a,i,r)},p:ne,d(a){a&&(t(s),t(c),t(u),t(p),t(v),t(i))}}}function he(H){let s,c,d,u,p,f,v,i,$="Hands-on exercise",a,r,z=`In this Unit, we consolidated the material covered in the previous six units of the course to build three integrated
audio applications. As you’ve experienced, building more involved audio tools is fully within reach by using the
foundational skills you’ve acquired in this course.`,L,b,F=`The hands-on exercise takes one of the applications covered in this Unit, and extends it with a few multilingual
tweaks 🌍 Your objective is to take the <a href="https://huggingface.co/spaces/course-demos/speech-to-speech-translation" rel="nofollow">cascaded speech-to-speech translation Gradio demo</a>
from the first section in this Unit, and update it to translate to any <strong>non-English</strong> language. That is to say, the
demo should take speech in language X, and translate it to speech in language Y, where the target language Y is not
English. You should start by <a href="https://huggingface.co/spaces/course-demos/speech-to-speech-translation?duplicate=true" rel="nofollow">duplicating</a>
the template under your Hugging Face namespace. There’s no requirement to use a GPU accelerator device - the free CPU
tier works just fine 🤗 However, you should ensure that the visibility of your demo is set to <strong>public</strong>. This is required
such that your demo is accessible to us and can thus be checked for correctness.`,P,T,G=`Tips for updating the speech translation function to perform multilingual speech translation are provided in the
section on <a href="speech-to-speech">speech-to-speech translation</a>. By following these instructions, you should be able
to update the demo to translate from speech in language X to text in language Y, which is half of the task!`,q,_,N=`To synthesise from text in language Y to speech in language Y, where Y is a multilingual language, you will need
to use a multilingual TTS checkpoint. For this, you can either use the SpeechT5 TTS checkpoint that you fine-tuned
in the previous hands-on exercise, or a pre-trained multilingual TTS checkpoint. There are two options for pre-trained
checkpoints, either the checkpoint <a href="https://huggingface.co/sanchit-gandhi/speecht5_tts_vox_nl" rel="nofollow">sanchit-gandhi/speecht5_tts_vox_nl</a>,
which is a SpeechT5 checkpoint fine-tuned on the Dutch split of the <a href="https://huggingface.co/datasets/facebook/voxpopuli" rel="nofollow">VoxPopuli</a>
dataset, or an MMS TTS checkpoint (see section on <a href="../chapter6/pre-trained_models">pretrained models for TTS</a>).`,E,x,Y,w,O=`Your demo should take as input an audio file, and return as output another audio file, matching the signature of the
<a href="https://huggingface.co/spaces/course-demos/speech-to-speech-translation/blob/3946ba6705a6632a63de8672ac52a482ab74b3fc/app.py#L35" rel="nofollow"><code>speech_to_speech_translation</code></a>
function in the template demo. Therefore, we recommend that you leave the main function <code>speech_to_speech_translation</code>
as is, and only update the <a href="https://huggingface.co/spaces/course-demos/speech-to-speech-translation/blob/a03175878f522df7445290d5508bfb5c5178f787/app.py#L24" rel="nofollow"><code>translate</code></a>
and <a href="https://huggingface.co/spaces/course-demos/speech-to-speech-translation/blob/a03175878f522df7445290d5508bfb5c5178f787/app.py#L29" rel="nofollow"><code>synthesise</code></a>
functions as required.`,A,k,R=`Once you have built your demo as a Gradio demo on the Hugging Face Hub, you can submit it for assessment. Head to the
Space <a href="https://huggingface.co/spaces/huggingface-course/audio-course-u7-assessment" rel="nofollow">audio-course-u7-assessment</a> and
provide the repository id of your demo when prompted. This Space will check that your demo has been built correctly by
sending a sample audio file to your demo and checking that the returned audio file is indeed non-English. If your demo
works correctly, you’ll get a green tick next to your name on the overall <a href="https://huggingface.co/spaces/MariaK/Check-my-progress-Audio-Course" rel="nofollow">progress space</a> ✅`,I;return f=new re({}),x=new ie({props:{$$slots:{default:[le]},$$scope:{ctx:H}}}),{c(){s=l("meta"),c=g(),d=l("h1"),u=l("a"),p=l("span"),J(f.$$.fragment),v=g(),i=l("span"),i.textContent=$,a=g(),r=l("p"),r.textContent=z,L=g(),b=l("p"),b.innerHTML=F,P=g(),T=l("p"),T.innerHTML=G,q=g(),_=l("p"),_.innerHTML=N,E=g(),J(x.$$.fragment),Y=g(),w=l("p"),w.innerHTML=O,A=g(),k=l("p"),k.innerHTML=R,this.h()},l(e){const n=se("svelte-1phssyn",document.head);s=h(n,"META",{name:!0,content:!0}),n.forEach(t),c=y(e),d=h(e,"H1",{class:!0});var S=U(d);u=h(S,"A",{id:!0,class:!0,href:!0});var X=U(u);p=h(X,"SPAN",{});var B=U(p);K(f.$$.fragment,B),B.forEach(t),X.forEach(t),v=y(S),i=h(S,"SPAN",{"data-svelte-h":!0}),m(i)!=="svelte-1mo6yzd"&&(i.textContent=$),S.forEach(t),a=y(e),r=h(e,"P",{"data-svelte-h":!0}),m(r)!=="svelte-5fgwkf"&&(r.textContent=z),L=y(e),b=h(e,"P",{"data-svelte-h":!0}),m(b)!=="svelte-1vndh8y"&&(b.innerHTML=F),P=y(e),T=h(e,"P",{"data-svelte-h":!0}),m(T)!=="svelte-1xc515h"&&(T.innerHTML=G),q=y(e),_=h(e,"P",{"data-svelte-h":!0}),m(_)!=="svelte-e3qygk"&&(_.innerHTML=N),E=y(e),K(x.$$.fragment,e),Y=y(e),w=h(e,"P",{"data-svelte-h":!0}),m(w)!=="svelte-r6bgbz"&&(w.innerHTML=O),A=y(e),k=h(e,"P",{"data-svelte-h":!0}),m(k)!=="svelte-xkt7xj"&&(k.innerHTML=R),this.h()},h(){M(s,"name","hf:doc:metadata"),M(s,"content",JSON.stringify(ce)),M(u,"id","handson-exercise"),M(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),M(u,"href","#handson-exercise"),M(d,"class","relative group")},m(e,n){C(document.head,s),o(e,c,n),o(e,d,n),C(d,u),C(u,p),V(f,p,null),C(d,v),C(d,i),o(e,a,n),o(e,r,n),o(e,L,n),o(e,b,n),o(e,P,n),o(e,T,n),o(e,q,n),o(e,_,n),o(e,E,n),V(x,e,n),o(e,Y,n),o(e,w,n),o(e,A,n),o(e,k,n),I=!0},p(e,[n]){const S={};n&2&&(S.$$scope={dirty:n,ctx:e}),x.$set(S)},i(e){I||(Q(f.$$.fragment,e),Q(x.$$.fragment,e),I=!0)},o(e){W(f.$$.fragment,e),W(x.$$.fragment,e),I=!1},d(e){e&&(t(c),t(d),t(a),t(r),t(L),t(b),t(P),t(T),t(q),t(_),t(E),t(Y),t(w),t(A),t(k)),t(s),Z(f),Z(x,e)}}}const ce={local:"handson-exercise",title:"Hands-on exercise"};function ue(H){return te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ge extends oe{constructor(s){super(),ae(this,s,ue,he,ee,{})}}export{ge as component};
